% Bild einlesen, B enthaelt Farbdaten
B=imread(name);
B=imresize(B,[600,800]);
B=double(B)/255;

% Referenzfarbe speichern
refCRGB=[0.0039,0.6314,0];

% Bildmatrizen erzeugen, die nur die Referenzfarbe 
% in jedem Pixel enthalten
nn=size(B);
refCMatRGB=repmat(permute(refCRGB,[1,3,2]),nn(1),nn(2));
% Konvertierung nach HSV
refCMatHSV=rgb2hsv(refCMatRGB);
refCHSV=permute(refCMatHSV(1,1,:),[1,3,2]);

% Farbdistanzen berechnen, komponentenweise
abst1=B-refCMatRGB;
abst2=rgb2hsv(B)-refCMatHSV;

% RGB Metrik, euklidische Distanz
dist1=sqrt(sum(abst1.^2,3));
% HSV Metrik, Kanaele gewichtet
dist2=sqrt(1*abst2(:,:,1).^2+1*abst2(:,:,2).^2+0.1*abst2(:,:,3).^2);

% Ipix1 und 2 enthalten 1 an gefundenen Pixeln, 0 sonst
Ipix1=dist1<tol1;
Ipix2=dist2<tol2;
