function [center]=myKmeans(X,anzClust,centerIni)
% X         : 2xn Matrix, jede Spalte ist ein Punkt der Punktewolke
% anzClust  : anzahl der zu findenen Zentren
% centerIni : Startpositionen der Zentren

% Initialisierungen
center=centerIni;
clustIndices=1:anzClust;
anzPkt=size(X,2);
abstSum=zeros(1,anzClust);
gesamtSum=1e100;
gesamtSumAlt=inf;
anzIt=0;
% Mittelwert und Standardabweichung Punktewolke
M=sum(X,2)/anzPkt;
var=sqrt(sum(sum((X-repmat(M,[1,anzPkt])).^2,1),2)/anzPkt);
% Hauptschleife
while (gesamtSum<gesamtSumAlt)&&(anzIt<100)
    gesamtSumAlt=gesamtSum;
    % Finde zu jedem Punkt das naechstliegende Clusterzentrum
    dist=repmat(X,[1,1,anzClust])...
    	 -repmat(permute(center,[1,3,2]),[1,anzPkt,1]);
    norm=dist(1,:,:).^2+dist(2,:,:).^2;
    [~,minI]=min(norm,[],3);
    % Finde heraus, ob und welche Clusterzentren nicht vorkommen
    [c]=unique(minI);
    c2=setdiff(clustIndices,c);
    % c2 enthaelt Indices der nicht zugewiesenen Clusterzentren, diese
    % werden spaeter neu positioniert
    % Basierend auf der aktuellen Clusterzuweisung, errechne neue
    % Schwerpunkte
    for k=1:anzClust
        % Berechne die neuen Zentren
        center(:,k)=sum(X(:,minI==k),2)/sum(minI==k);
        % Berechne die Abstandssumme fuer Cluster k
        abstSum(k)=sum(sum((X(:,minI==k)...
        	-repmat(center(:,k),[1,sum(minI==k)])).^2,1),2);
    end
    % Clusterzentren, die nicht zugewiesen wurden, werden zufaellig um
    % das erste Clusterzentrum neu positioniert
    center(:,c2)=var*rand(2,length(c2))...
    	+repmat(center(:,c(1)),[1,length(c2)]);
    % Gesamtsumme der Abstaende der Punkte zu den zugeordneten
    % Clusterzentren
    gesamtSum=sum(abstSum,2);
    anzIt=anzIt+1;
end
